<?php

    declare(strict_types=1);

    /**
     * User: Daschmi  
     * Date: 13.02.2020
     * Time: 06:25
     */

    namespace wpsg;

    abstract class Action {

        public static function enqueue_block_editor_assets() {
 
            \wp_enqueue_style('wpsg-block', \wpsg_ShopController::getShop()->getRessourceURL('css/gutenberg.css'));

            \wp_register_script(
                'wpsg-block-product',
                \wpsg_ShopController::getShop()->getRessourceURL('js/wpsg-block-product.js'),
                ['wp-blocks', 'wp-editor', 'wp-element', 'wp-components'],
                filemtime(\wpsg_ShopController::getShop()->getRessourcePath('js/wpsg-block-product.js'))
            );
              
            $arProductSelect = \wpsg_ShopController::getShop()->db->fetchAssoc("
                SELECT 
                    `id` AS `value`, IF (`name` = '', '---', `name`) AS `label`
                FROM
                    `".WPSG_TBL_PRODUCTS."` AS P
                ORDER BY
                    P.`name` ASC
            ");

            $arTempalteSelect = [];

            foreach (\wpsg_ShopController::getShop()->loadProduktTemplates() as $template_file) {

                $arTempalteSelect[] = ['value' => $template_file, 'label' => $template_file];

            }

            $data = [
                'arProductSelect' => array_merge([['value' => '-1', 'label' => __('Alle Produkte')]], $arProductSelect),
                'arTemplateSelect' => $arTempalteSelect,
                'arHideTitleSelect' => [
                    ['value' => '1', 'label' => __('nicht anzeigen', 'wpsg')],
                    ['value' => '0', 'label' => __('anzeigen', 'wpsg')]
                ],
                'label' => [
                    'product' => __('Produkt', 'wpsg'),
                    'template' => __('Template', 'wpsg'),
                    'hide_title' => __('Titel anzeigen', 'wpsg')
                ]
            ];

            \wp_localize_script('wpsg-block-product', 'wpsg_block_product', $data);

        }

        public static function wpsg_hourly_hook() {
 
            $oReminder = new \Wpsg\Reminder();
            $oReminder->cronService();
            
        }
        
    }
