<?php

    /**
     * User: Daschmi (https://daschmi.de)
     * Date: 18.05.2017
     * Time: 08:57
     */

    namespace wpsg;
 
    class Exception extends \Exception
    {
        
        const TYP_UNEXPECTED = 0;
        const TYP_DB = 1;
        const TYP_EXT_URL = 2;
         
        private $typ = null;
        private $data = null;
        
        public function __construct($message, $typ = null, $arData = array(), $code = 0, Exception $previous = null) {
                        
            parent::__construct($message, $code, $previous);
            
            if ($typ === null) $typ = self::TYP_UNEXPECTED;
            
            $this->typ = $typ;
            $this->data = $arData;
            
        } // public function __construct($message, $code = 0, Exception $previous = null)

        public function getData()
        {

            return $this->data;

        }

        public function getTypLabel() 
        {
        
            switch ($this->typ)
            {
                
                case self::TYP_UNEXPECTED: return __('Unerwartetes Programmverhalten', 'wpsg'); break;
                case self::TYP_DB: return __('Datenbankfehler', 'wpsg'); break;
				case self::TYP_EXT_URL: return __('Fehler bei externem URL Aufruf', 'wpsg'); break;
                
                default: return __('Ungekannter Fehlertyp', 'wpsg'); break;
                
            } // switch ($this->_typ)
            
        } // public function getTypLabel()
		
		public static function getMethodNotFoundException($func_name = "") {
        	
        	return new \Exception(wpsg_translate(__('Funktion (#1#) existiert nicht', 'wpsg'), $func_name));
        	
		}
		
		public static function getSanitizeException() {
        	
			debug_print_backtrace();
			
        	return new \Exception('Parameterfehler');
        	
		}
		
		public static function getInvalidValueException() {
        	
        	return new \Exception('Aufrufsfehler');
        	
		}

		public static function getInvalidFunctionException() {

            return new \Exception('Ungültiger Aufruf');

        }
        
    } // class exception extends \Exception