<?php

	/**
	 * Modul für das Modul Flächenprodukt
	 */
	
	class wpsg_mod_surfaceproduct extends wpsg_mod_basic
	{
	
		var $lizenz = 1;
		var $id = 5400;
		//var $version = "4.4.2";
		var $hilfeURL = 'http://wpshopgermany.de/?p=5729960';
		
		const MODE_RUNNING = 1;
		const MODE_HEIGHTWIDE = 2;
	
		
		/**
		 * Constructor
		 */
		public function __construct()
		{
				
			global $wpdb;
				
			parent::__construct();
		
			$this->name = __('Druckerei', 'wpsg');
			$this->group = __('Produkte', 'wpsg');
			$this->desc = __('Ermöglicht die Integration von flächenberechneten Produkten.', 'wpsg');
				
		} // public function __construct()
		
		public function install()
		{
		
			require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php');
		
			/**
			 * Produkttabelle erweitern
			 */
			$sql = "CREATE TABLE ".WPSG_TBL_PRODUCTS." (			  	
				wpsg_mod_surfaceproduct_productactiv int(1) NOT NULL,
				wpsg_mod_surfaceproduct_mode VARCHAR(255) NOT NULL,
				wpsg_mod_surfaceproduct_mode_running VARCHAR(255) NOT NULL							
			) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
				
			dbDelta($sql);
			
			/**
			 * Bestelltabelle (order_products) erweitern
			 */
			$sql = "CREATE TABLE ".WPSG_TBL_ORDER_PRODUCTS." (
				wpsg_mod_surfaceproduct_running_order VARCHAR (255) NOT NULL,
				wpsg_mod_surfaceproduct_mode_length VARCHAR(255) NOT NULL,
				wpsg_mod_surfaceproduct_mode_both VARCHAR(255) NOT NULL
			) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
			
			dbDelta($sql);
			
			/**
			 * Tabelle für die FlächenProdukte
			 */
			$sql = "CREATE TABLE ".WPSG_TBL_SURFACEPRODUCT." (
				id int(11) NOT NULL AUTO_INCREMENT,
				PRIMARY KEY  (id),
				wpsg_mod_surfaceproduct_activ int(1) DEFAULT 0 NOT NULL,
				wpsg_mod_surfaceproduct_einheit VARCHAR(255) NOT NULL,
				wpsg_mod_surfaceproduct_faktor VARCHAR(255) NOT NULL
			) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
				
			dbDelta($sql);
			
		} // public function install()
		
		public function product_addedit_content(&$product_content, &$product_data)
		{
		
			$product_content['wpsg_mod_surfaceproduct'] = array(
					'title' => __('Druckerei', 'wpsg'),
					'content' => $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_surfaceproduct/produkt_edit_sidebar.phtml', false)
			);
		}
		
		public function settings_edit()
		{
		
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_surfaceproduct/settings_edit.phtml');
		
		}
		
		public function settings_save()
		{

		    $this->shop->update_option('wpsg_mod_surfaceproduct_einheit', $_REQUEST['wpsg_mod_surfaceproduct_einheit'], false, false, WPSG_SANITIZE_TEXTFIELD);
		    $this->shop->update_option('wpsg_mod_surfaceproduct_faktor', $_REQUEST['wpsg_mod_surfaceproduct_faktor'], false, false, WPSG_SANITIZE_TEXTFIELD);

		} // public function settings_save()
		
		public function produkt_save_before(&$produkt_data)
		{
			//wpsg_debug($_REQUEST);
			
			$produkt_data['wpsg_mod_surfaceproduct_productactiv'] = wpsg_q(wpsg_sinput("key", $_REQUEST['wpsg_mod_surfaceproduct']['wpsg_mod_surfaceproduct_productactiv']));
			$produkt_data['wpsg_mod_surfaceproduct_mode'] = wpsg_q(wpsg_sinput("key", $_REQUEST['wpsg_mod_surfaceproduct']['wpsg_mod_surfaceproduct_mode']));
			$produkt_data['wpsg_mod_surfaceproduct_mode_running'] = wpsg_q(wpsg_sinput("key", $_REQUEST['wpsg_mod_surfaceproduct']['wpsg_mod_surfaceproduct_mode_running']));
			
			//wpsg_debug($produkt_data);
			//die;
			
		} // public function settings_save()
		
		public function order_save(&$order_data)
		{		  
		 
		  $order_data['wpsg_mod_surfaceproduct_running_order'] = wpsg_q(wpsg_xss($_REQUEST['wpsg_mod_surfaceproduct']['wpsg_mod_surfaceproduct_running_order']));
		  $order_data['wpsg_mod_surfaceproduct_mode_length'] = wpsg_q(wpsg_xss($_REQUEST['wpsg_mod_surfaceproduct']['wpsg_mod_surfaceproduct_mode_length']));
		  $order_data['wpsg_mod_surfaceproduct_mode_both'] = wpsg_q(wpsg_xss($_REQUEST['wpsg_mod_surfaceproduct']['wpsg_mod_surfaceproduct_mode_both']));
		 
		 }
		 
		 
		public function renderTemplate()
		{
			
			return $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_surfaceproduct/product.phtml');
			
		}
		
		public function mail_row($index, $produkt)
		{
		
			if ($this->shop->htmlMail === true) $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_surfaceproduct/mail_row_html.phtml');
			else $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_surfaceproduct/mail_row.phtml');
			
		}
		
		public function basket_row(&$p, $i)
		{
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_surfaceproduct/basket_row.phtml');
			
		}
		
		public function overview_row(&$p, $i)
		{
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_surfaceproduct/order_row.phtml');
			
		}
		
		public function wpsg_mod_export_loadFields(&$arFields)
		{
			
			$arFields[10]['fields']['mod_surfaceproduct_mode_running'] = __('Laufmeter', 'wpsg');
			$arFields[10]['fields']['mod_surfaceproduct_running_order'] = __('', 'wpsg');
			$arFields[10]['fields']['mod_surfaceproduct_mode_length'] = __('Länge', 'wpsg');
			$arFields[10]['fields']['mod_surfaceproduct_mode_both'] = __('Breite', 'wpsg');			
			
		}
		 
	} 