<?php

    declare(strict_types=1);

    /**
     * User: Daschmi
     * Date: 19.10.2020
     * Time: 13:51
     */

    namespace Wpsg;

    class Reminder extends Service {

        public function cronService() {

            $hours = intval($this->shop->get_option('wpsg_reminder_hours'));

            if ($hours <= 0) return;

            $strQuery = "
                SELECT
                    O.`id`
                FROM
                    `".WPSG_TBL_ORDER."` AS O
                        LEFT JOIN `".WPSG_TBL_META."` AS M ON (O.`id` = M.`target_id` AND M.`meta_key` = 'wpsg_reminder')
                WHERE
                     M.`meta_value` IS NULL AND 
                     O.`status` = '".wpsg_q(\wpsg_ShopController::STATUS_UNVOLLSTAENDIG)."' AND
                     DATE_ADD(O.`cdate`, INTERVAL ".wpsg_q($hours)." HOUR) < NOW()
                GROUP BY
                    O.`id`
            ";

            $arOrderIDToRemind = $this->db->fetchAssocField($strQuery);

            foreach ($arOrderIDToRemind as $order_id) {

                $oOrder = \wpsg_order::getInstance($order_id);

                $this->shop->view = [
                    'oOrder' => $oOrder
                ];

                $mail_text = $this->shop->render(WPSG_PATH_VIEW.'/mailtemplates/reminder.phtml', false);

                if ($this->shop->get_option('wpsg_htmlmail') === '1') $mail_html = $this->shop->render(WPSG_PATH_VIEW.'/mailtemplates/html/reminder.phtml', false);
                else $mail_html = false;
 
                $this->shop->sendMail($mail_text, $oOrder->getCustomer()->getEMail(), 'reminder', [], $order_id, $oOrder->getCustomer()->getId(), $mail_html);

                $oOrder->addLogEntry('Erinnerung wegen Nichtabschluss', $mail_text);
                $oOrder->setMeta('wpsg_reminder', time());

            }

        }

    }
